#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <vip>

public Plugin:myinfo = 
{
	name	= "VIP [Bullet Trail]",
	author	= "wS",
	version = "1.1.2"
};

#define SPEED		6000.0
#define ITEM_NAME 	"bullet_trail"

new bool:g_bAccess[MAXPLAYERS + 1];
new Float:g_fLastImpact[MAXPLAYERS + 1];
new g_iEffectEnt;

public OnPluginStart()
{
	if (!VIP_RegisterItem(ITEM_NAME, VIP_ITEM_TOGGLE)) SetFailState("VIP_RegisterItem error (%s)", ITEM_NAME);
	HookEvent("bullet_impact", bullet_impact, EventHookMode_Post);
}

///////////////////////////////////////////////////////////////////////////////////

public bool:VIP_CurrentItemValue(client, ItemID, String:ItemValue[], ItemValueSize)
{
	if (g_bAccess[client])
	{
		IntToString(1, ItemValue, ItemValueSize);
		return true;
	}
	ItemValue[0] = 0;
	return false;
}

public VipGiveAction:VIP_GiveAccess(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], bool:bCallAfterAdminAction, CURRENT_ACCESS, Handle:kv)
{
	if (g_bAccess[client]) return VGA_AlreadyEnabled;
	SetStatus(client, true);
	return VGA_Continue;
}

public VIP_TakeAccess(client, ItemID, bool:bToggledByClient)
{
	SetStatus(client, false);
}

stock SetStatus(client, bool:enabled)
{
	g_bAccess[client] = enabled;
	VIP_NotifyItemStatusChanged(client, ITEM_NAME, enabled);
}

///////////////////////////////////////////////////////////////////////////////////

public OnMapStart()
{
	g_iEffectEnt = PrecacheModel("materials/sprites/laserbeam.vmt", true);
	PrecacheModel("sprites/glow01.spr", true);
}

public OnConfigsExecuted()
{
	static Handle:hCvar = INVALID_HANDLE;
	if (hCvar || (hCvar = FindConVar("sv_maxvelocity")))
	{
		if (GetConVarFloat(hCvar) < SPEED) SetConVarFloat(hCvar, SPEED + 5.0);
		HookConVarChange(hCvar, cvar_changed);
	}
}

public cvar_changed(Handle:hCvar, const String:OldValue[], const String:NewValue[]) { if (StringToFloat(NewValue) < SPEED) SetConVarFloat(hCvar, SPEED + 5.0); }
public OnClientPutInServer(client) g_fLastImpact[client] = 0.0;
public OnClientDisconnect(client) g_bAccess[client] = false;
public StartTouch(entity, other) AcceptEntityInput(entity, "Kill");

public bullet_impact(Handle:event, const String:name[], bool:silent)
{
	static Float:f, client;
	if (g_bAccess[(client = GetClientOfUserId(GetEventInt(event, "userid")))] && ((f = GetGameTime()) - g_fLastImpact[client]) > 0.0)
	{
		g_fLastImpact[client] = f;

		new entity = CreateEntityByName("smokegrenade_projectile");
		if (entity < 1)
			return;
		
		DispatchKeyValue(entity, "targetname", "bullet_trail");

		decl Float:v_start[3];
		GetClientEyePosition(client, v_start);

		decl Float:v_end[3];
		v_end[0] = GetEventFloat(event, "x");
		v_end[1] = GetEventFloat(event, "y");
		v_end[2] = GetEventFloat(event, "z");

		decl Float:direction[3];
		GetClientEyeAngles(client, direction);
		GetAngleVectors(direction, direction, NULL_VECTOR, NULL_VECTOR);
		v_start[0] += direction[0] * 5.0;
		v_start[1] += direction[1] * 5.0;

		// FrozDark
		MakeVectorFromPoints(v_start,		v_end,			v_end);
		GetVectorAngles(v_end,	direction);
		NormalizeVector(v_end,	v_end);
		ScaleVector(v_end,		SPEED);

		DispatchKeyValueVector(entity,		"origin",		v_start);
		SetEntPropEnt(entity,	Prop_Send,	"m_hOwnerEntity",	client);
		SetEntProp(entity,		Prop_Send,	"m_fEffects",	GetEntProp(entity, Prop_Send, "m_fEffects") | 32);
		DispatchSpawn(entity);
		SetEntityMoveType(entity,			MOVETYPE_FLY);

		new team	= GetClientTeam(client);
		TE_SetupBeamFollow(entity, g_iEffectEnt, g_iEffectEnt, 0.1, 1.0, 1.0, 0, team == 2 ? {255,0,0,255} : {0,0,255,255});
		TE_SendToAll();

		new sprite	= CreateEntityByName("env_sprite");
		if (sprite	> 0)
		{
			DispatchKeyValueVector(sprite,	"origin",		v_start);
			DispatchKeyValue(sprite,		"model",		"sprites/glow01.spr");
			DispatchKeyValue(sprite,		"rendermode",	"5");
			DispatchKeyValue(sprite,		"renderamt",	"255");
			DispatchKeyValue(sprite,		"rendercolor",	team == 2 ? "255 0 0" : "0 0 255");
			DispatchKeyValue(sprite,		"scale",		"0");
			DispatchSpawn(sprite);
			SetVariantString("!activator");
			AcceptEntityInput(sprite,		"SetParent",	entity,	sprite);
			AcceptEntityInput(sprite,		"ShowSprite");
		}

		TeleportEntity(entity, v_start, direction, v_end);
		SDKHook(entity, SDKHook_StartTouch, StartTouch);
	}
}